package jpatp.cascade;

import java.util.List;
import javax.persistence.Query;
import javax.persistence.EntityManager;
import jpa.test.client.*;



public class Client extends ClientJPABase
{
    private Query query;

    private EntityManager em;

    public static void main(String args[])
    {

        Client cl = new Client("em1");
        cl.cascade001();
        cl.cleanup();
    }

    // constructor
    private Client(String unitname)
    {
        super(unitname);
    }
    
 
    /**
     * CLID001
     * 
     * @return
     */
     
    public boolean cascade001()
    {
        testStart("cascade001");
        try
        {
            
            em = getEntityManager();
            // TP log begins
            // transaction begins
            transactionBegin();
            
            Address2 address = new Address2(1,1,"KAWASAKI");
            em.persist(address);
                       
            Employee2 employee = new Employee2(1);
            employee.setAddress(address);
            em.persist(employee);                       
            //em.merge(employee);
            em.flush();
            transactionCommit();
            transactionBegin();
            
            query = em.createNativeQuery("UPDATE ADDRESS2 SET CITY = 'YOKOHAMA'");
            query.executeUpdate();
            transactionCommit();
            transactionBegin();
            em.refresh(employee);
            
            
            query = em.createQuery("select p from Employee2 p");

            // The compilation warning: evade no inspection Cast
            List<Employee2> results = PersonEntitie.<Employee2> getList(query.getResultList());

            // data update
            for(Employee2 emp : results)
            {
				System.out.println("## ID = " + emp.getID() +  " MYID = " + emp.getAddress().getMYID() + " CITY = " + emp.getAddress().getCITY());
                log("## ID = " + emp.getID() +  " MYID = " + emp.getAddress().getMYID() + " CITY = " + emp.getAddress().getCITY());
                detail("## ID = " + emp.getID() + " MYID = " + emp.getAddress().getMYID() + " CITY = " + emp.getAddress().getCITY());
                
                em.merge(emp);
            }

            // commit transaction
            transactionCommit();
        }
        catch(Throwable th)
        {
            detail("Unexpected exception occured.");
            detail(th.getMessage());
            th.printStackTrace();
            failed("Unexpected exception occured.", th);
            transactionRollback();
        }
        finally
        {
            testEnd();
        }
        return true;
    }

}
